scheduler._get_real_event_length=function(sd, fd, obj){
	var ev_length = fd - sd;
	var hours = (obj._start_correction + obj._end_correction)||0;
	var ignore = this["ignore_"+this._mode];
	var start_slot = 0,
		end_slot = 0;

	if (obj.render){
	
		while (ignore && ignore(fd)){
			fd = scheduler.date.add(fd, obj.x_step, obj.x_unit); // if end date is in the ignored period, find next visible period
		}
		ev_length = fd - sd;
		
		if(+sd < +scheduler._min_date)
			start_slot = this._get_fictional_start_date_index(obj, sd);
		else
			start_slot = this._get_date_index(obj, sd);
		
		if(+fd < +scheduler._max_date)
			end_slot = this._get_date_index(obj, fd);
		else
			end_slot = this._get_fictional_end_date_index(obj, fd);
	} else{
		end_slot = Math.round(ev_length/60/60/1000/24);
	}

	while (start_slot < end_slot){
		var check = scheduler.date.add(fd, -obj.x_step, obj.x_unit);
		if (ignore && ignore(fd))
			ev_length -= (fd-check);
		else
			ev_length -= hours;

		fd = check;
		end_slot--;
	}
	return ev_length;
};

scheduler._get_fictional_event_length=function(end_date, ev_length, obj, back){
	var sd = new Date(end_date);
	var dir = back ? -1 : 1;

	//get difference caused by first|last hour
	if (obj._start_correction || obj._end_correction){
		if (back)
			var today = (sd.getHours()*60+sd.getMinutes()) - (obj.first_hour||0)*60;
		else
			var today = (obj.last_hour||0)*60 - (sd.getHours()*60+sd.getMinutes());
		var per_day = (obj.last_hour - obj.first_hour)*60;
		var days = Math.ceil( (ev_length / (60*1000) - today ) / per_day);
		ev_length += days * (24*60 - per_day) * 60 * 1000;
	}

	var fd = new Date(end_date*1+ev_length*dir);
	var ignore = this["ignore_"+this._mode];

	var start_slot = 0,
		end_slot;

	if (obj.render){
		// get a correct index for the date
		if(+sd < +scheduler._min_date)
			start_slot = this._get_fictional_start_date_index(obj, sd);
		else if(+sd < +scheduler._max_date)
			start_slot = this._get_date_index(obj, sd);
		else
			start_slot = this._get_fictional_end_date_index(obj, sd);
		
		if(+fd < +scheduler._min_date)
			end_slot = this._get_fictional_start_date_index(obj, fd);
		else if(+fd < +scheduler._max_date)
			end_slot = this._get_date_index(obj, fd);
		else
			end_slot = this._get_fictional_end_date_index(obj, fd);
	} else{
		var end_slot = Math.round(ev_length/60/60/1000/24);
	}

	while (start_slot*dir <= end_slot*dir){
		var check = scheduler.date.add(sd, obj.x_step*dir, obj.x_unit);
		if (ignore && ignore(sd)){
			ev_length += (check-sd)*dir;
			end_slot += dir;
		}

		sd = check;
		start_slot+=dir;
	}
	return ev_length;
};

// _get_fictional_start_date_index and _get_fictional_end_date_index
// return index of the dates outside of the current view period
scheduler._get_fictional_start_date_index = function(config, date) {
	var index = 0,// index of the first column
		step = config.x_step,
		unit = config.x_unit,
		temp_date = new Date(scheduler._min_date);
	while (+temp_date > +date) {
		temp_date = scheduler.date.add(temp_date,-1*step,unit);
		index--;
	}
	return index;
};

scheduler._get_fictional_end_date_index = function(config, date) {
	var index = config._trace_x.length-1,// index of the last column
		step = config.x_step,
		unit = config.x_unit,
		temp_date = new Date(scheduler._max_date);
	while (+temp_date < +date) {
		temp_date = scheduler.date.add(temp_date,step,unit);
		index++;
	}
	return index;
};